/*
Written by Ed Hong
UWT
Jan. 22, 2003
modified June 8, 2003
modified May 26, 2004
 */

import java.util.*;


public class UnsortedArrayPQ {

   // internal class for containing 
    // pq items, including (key,object,and locator). 
    // no methods beside constructor. 
  private class pqitem {
      public double key;
      public Object element;
      public uapqLoc loc;
      public pqitem(double k, Object o) {
	key = k;
	element = o;	
	loc = new uapqLoc(this); // initialize locator to point to this item
      }
  }

  private class uapqLoc implements Locator {
      private pqitem locatordat; // reference to item inside pq
      // constructor.. 
      private uapqLoc(pqitem k) {
	  locatordat = k;
      }
      public double key() {
	  /* returns key (priority) associated to referenced data */
	  return locatordat.key;
      }
      public Object element() {
	  /* returns Object associated to referenced data */
	  return locatordat.element;
      }
  }

    private Vector pqdata;

    public UnsortedArrayPQ() {
	pqdata = new Vector();
    }

    public Locator insertItem(double key, Object o) {
	pqitem temp;
	temp = new pqitem(key, o);
	pqdata.add(temp);
	return temp.loc;
    }

    public Object removeMin() {
	int ind; // stores index of element with smallest key
	double smallkey; // stores smallest key
	pqitem temp; 

	if (pqdata.size()==0) return null;

	ind =0;
	temp = (pqitem) pqdata.get(0);
	smallkey = temp.key;
	//	    System.out.println("PQDAT: item " + temp + " (" + 0 + ") is (" + 
	//	       temp.key + ", " + 
	//	       temp.element + ")");
	// search for item with smallest key. 
	for (int i=1; i < pqdata.size(); i++) {
	    temp = (pqitem) pqdata.get(i);
	    //	    System.out.println("PQDAT: item " + temp + " (" + i + ") is (" + 
	    //	       temp.key + ", " + 
	    //	       temp.element + ")");
	    if (temp.key < smallkey) {
		smallkey = temp.key;
		ind = i;
	    }
	}
	temp = (pqitem) pqdata.get(ind);
	pqdata.removeElementAt(ind);
	temp.loc.locatordat = null;
	return temp.element;
    }

    public void replaceKey(Locator l, double newkey) {
	uapqLoc ul = (uapqLoc) l;
	if (ul.locatordat==null) {
	    System.out.println("Error in replaceKey(): locator refers to object not in PQ! Ignoring call!");
	    return;
	}	    
	ul.locatordat.key = newkey;
	//	System.out.println("ReplaceKey:  newkey " + newkey + 
	//	   "; locaterdat = " + l.locatordat + ";");
	//  System.out.println("RPQDAT: item " + l.locatordat + " is (" + 
	//	       l.locatordat.key + ", " + 
	//	       l.locatordat.element + ")");
    }

    public boolean isEmpty() {
	return (pqdata.size() == 0);
    }
}

